<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.6"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>HTTP: src/server.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">HTTP
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.6 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">server.h</div></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">// This file is part of the SHPP distribution.</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment">// Copyright (c) 2023 Shahriar Rezghi.</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment">//</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment">// SHPP is free software: you can redistribute it and/or modify</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment">// it under the terms of the GNU General Public License as published by</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment">// the Free Software Foundation, version 3.</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment">//</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment">// SHPP is distributed in the hope that it will be useful, but</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment">// WITHOUT ANY WARRANTY; without even the implied warranty of</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">// General Public License for more details.</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment">//</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment">// You should have received a copy of the GNU General Public License</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment">// along with SHPP. If not, see &lt;http://www.gnu.org/licenses/&gt;.</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &lt;cstdint&gt;</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &lt;functional&gt;</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span> </div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &quot;common.h&quot;</span></div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespaceSHPP.html">SHPP</a></div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>{</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno"><a class="line" href="classSHPP_1_1Server.html">   27</a></span><span class="keyword">class </span><a class="code hl_class" href="classSHPP_1_1Server.html">Server</a></div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>{</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span><span class="keyword">public</span>:</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno"><a class="line" href="classSHPP_1_1Server.html#a7815b7fd1249097aede0b5601901e094">   31</a></span>    <span class="keyword">using </span><a class="code hl_typedef" href="classSHPP_1_1Server.html#a7815b7fd1249097aede0b5601901e094">Handler</a> = std::function&lt;<a class="code hl_struct" href="structSHPP_1_1Response.html">Response</a>(<span class="keyword">const</span> <a class="code hl_struct" href="structSHPP_1_1Request.html">Request</a> &amp;)&gt;;</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno"><a class="line" href="classSHPP_1_1Server.html#ab17fb726ec450fc49b892fb74c939460">   34</a></span>    <span class="keyword">inline</span> <a class="code hl_function" href="classSHPP_1_1Server.html#ab17fb726ec450fc49b892fb74c939460">Server</a>(<span class="keyword">const</span> <a class="code hl_typedef" href="classSHPP_1_1Server.html#a7815b7fd1249097aede0b5601901e094">Handler</a> &amp;handler) : handler(handler) {}</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span> </div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno"><a class="line" href="classSHPP_1_1Server.html#aba79b20af03be27856da541350b662ca">   39</a></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classSHPP_1_1Server.html#aba79b20af03be27856da541350b662ca">set_address</a>(<span class="keyword">const</span> std::string &amp;address) { this-&gt;address = address; }</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span> </div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno"><a class="line" href="classSHPP_1_1Server.html#a5aba82072355cce0d3aec6c49d589973">   44</a></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classSHPP_1_1Server.html#a5aba82072355cce0d3aec6c49d589973">set_port</a>(<span class="keyword">const</span> uint16_t &amp;port) { this-&gt;port = port; }</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span> </div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno"><a class="line" href="classSHPP_1_1Server.html#a1a4a206c82decb5aa85db417f168ad5b">   49</a></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classSHPP_1_1Server.html#a1a4a206c82decb5aa85db417f168ad5b">set_handler</a>(<span class="keyword">const</span> <a class="code hl_typedef" href="classSHPP_1_1Server.html#a7815b7fd1249097aede0b5601901e094">Handler</a> &amp;handler) { this-&gt;handler = handler; }</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span> </div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno"><a class="line" href="classSHPP_1_1Server.html#ad3ceec24e4a131346e8963fa26d38fa4">   54</a></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classSHPP_1_1Server.html#ad3ceec24e4a131346e8963fa26d38fa4">set_threads</a>(<span class="keyword">const</span> <span class="keywordtype">size_t</span> &amp;threads) { this-&gt;threads = threads; }</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span> </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno"><a class="line" href="classSHPP_1_1Server.html#a91b9ebc0bdd1e1dc2beac293bb501a51">   57</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classSHPP_1_1Server.html#a91b9ebc0bdd1e1dc2beac293bb501a51">run</a>();</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span> </div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span><span class="keyword">private</span>:</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>    std::string address = <span class="stringliteral">&quot;0.0.0.0&quot;</span>;</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>    uint16_t port = 8787;</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>    <a class="code hl_typedef" href="classSHPP_1_1Server.html#a7815b7fd1249097aede0b5601901e094">Handler</a> handler = {};</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>    <span class="keywordtype">size_t</span> threads = 8;</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>};</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>}  <span class="comment">// namespace SHPP</span></div>
<div class="ttc" id="aclassSHPP_1_1Server_html"><div class="ttname"><a href="classSHPP_1_1Server.html">SHPP::Server</a></div><div class="ttdoc">Class to create and run the HTTP server.</div><div class="ttdef"><b>Definition:</b> server.h:28</div></div>
<div class="ttc" id="aclassSHPP_1_1Server_html_a1a4a206c82decb5aa85db417f168ad5b"><div class="ttname"><a href="classSHPP_1_1Server.html#a1a4a206c82decb5aa85db417f168ad5b">SHPP::Server::set_handler</a></div><div class="ttdeci">void set_handler(const Handler &amp;handler)</div><div class="ttdef"><b>Definition:</b> server.h:49</div></div>
<div class="ttc" id="aclassSHPP_1_1Server_html_a5aba82072355cce0d3aec6c49d589973"><div class="ttname"><a href="classSHPP_1_1Server.html#a5aba82072355cce0d3aec6c49d589973">SHPP::Server::set_port</a></div><div class="ttdeci">void set_port(const uint16_t &amp;port)</div><div class="ttdef"><b>Definition:</b> server.h:44</div></div>
<div class="ttc" id="aclassSHPP_1_1Server_html_a7815b7fd1249097aede0b5601901e094"><div class="ttname"><a href="classSHPP_1_1Server.html#a7815b7fd1249097aede0b5601901e094">SHPP::Server::Handler</a></div><div class="ttdeci">std::function&lt; Response(const Request &amp;)&gt; Handler</div><div class="ttdoc">An alias for the handler callback function.</div><div class="ttdef"><b>Definition:</b> server.h:31</div></div>
<div class="ttc" id="aclassSHPP_1_1Server_html_a91b9ebc0bdd1e1dc2beac293bb501a51"><div class="ttname"><a href="classSHPP_1_1Server.html#a91b9ebc0bdd1e1dc2beac293bb501a51">SHPP::Server::run</a></div><div class="ttdeci">void run()</div><div class="ttdoc">Run the HTTP server.</div></div>
<div class="ttc" id="aclassSHPP_1_1Server_html_ab17fb726ec450fc49b892fb74c939460"><div class="ttname"><a href="classSHPP_1_1Server.html#ab17fb726ec450fc49b892fb74c939460">SHPP::Server::Server</a></div><div class="ttdeci">Server(const Handler &amp;handler)</div><div class="ttdoc">Initialize the server with the request handler.</div><div class="ttdef"><b>Definition:</b> server.h:34</div></div>
<div class="ttc" id="aclassSHPP_1_1Server_html_aba79b20af03be27856da541350b662ca"><div class="ttname"><a href="classSHPP_1_1Server.html#aba79b20af03be27856da541350b662ca">SHPP::Server::set_address</a></div><div class="ttdeci">void set_address(const std::string &amp;address)</div><div class="ttdef"><b>Definition:</b> server.h:39</div></div>
<div class="ttc" id="aclassSHPP_1_1Server_html_ad3ceec24e4a131346e8963fa26d38fa4"><div class="ttname"><a href="classSHPP_1_1Server.html#ad3ceec24e4a131346e8963fa26d38fa4">SHPP::Server::set_threads</a></div><div class="ttdeci">void set_threads(const size_t &amp;threads)</div><div class="ttdef"><b>Definition:</b> server.h:54</div></div>
<div class="ttc" id="anamespaceSHPP_html"><div class="ttname"><a href="namespaceSHPP.html">SHPP</a></div><div class="ttdoc">The namespace of the library.</div><div class="ttdef"><b>Definition:</b> common.h:27</div></div>
<div class="ttc" id="astructSHPP_1_1Request_html"><div class="ttname"><a href="structSHPP_1_1Request.html">SHPP::Request</a></div><div class="ttdoc">Wrapper class of an HTTP request.</div><div class="ttdef"><b>Definition:</b> common.h:30</div></div>
<div class="ttc" id="astructSHPP_1_1Response_html"><div class="ttname"><a href="structSHPP_1_1Response.html">SHPP::Response</a></div><div class="ttdoc">Wrapper class of an HTTP response.</div><div class="ttdef"><b>Definition:</b> common.h:52</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.6
</small></address>
</body>
</html>
